/*
 * COPYRIGHT INFORMATION - DO NOT REMOVE
 * "Portions Copyright (c) 2000-2001 LinuxMagic Inc. All Rights Reserved.
 *
 * This file contains Original Code and/or Modifications of Original Code as
 * defined in and that are subject to the Free Source Code License Version
 * 1.0 (the 'License'). You may not use this file except in compliance with
 * the License. Please obtain a copy of the License at:
 *
 * http://www.linuxmagic.com/opensource/licensing/
 *
 * and read it before using this file.
 *
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND LINUXMAGIC HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. Please see
 * the License for the specific language governing rights and limitations
 * under the License."
 *
 * Please read the terms of this license carefully. By using or downloading
 * this software or file, you are accepting and agreeing to the terms of this
 * license with LinuxMagic Inc. If you are agreeing to this license on behalf
 * of a company, you represent that you are authorized to bind the company to
 * such a license. If you do not meet this criterion or you do not agree to
 * any of the terms of this license, do NOT download, distribute, use or alter
 * this software or file in any way.
 *
 * Author: Burton Samograd (burton@wizard.ca)
 * CVS Id: $Id: check_user_db.c,v 1.9 2003/01/08 18:47:17 burton Exp $
 *
 * DO NOT MODIFY WITHOUT CONSULTING THE LICENSE
 */

/* LM libs includes */
#include <liblm.h>

/* Project includes */
#include "config_msd.h"
#include "check_user.h"
#include "db.h"

int msd_check_user_init_db(void)
{
	int retval = 0;
	/* Nothing to do, handled by db.c */
	LM_ASSERT(db != NULL);
	return retval;
}

int msd_check_user_cleanup_db(void)
{
	int retval = 0;
	/* Nothing to do, handled by db.c */
	return retval;
}

int msd_check_rcpt_user_db(lm_string_t* paddr, lm_string_t* pdotspam)
{
	int retval = 0;
	char qbuffer[1024];
	lm_string_t addr = NULL;
	char *escuser = NULL;
	char *escdomain = NULL;

	/* Check to make sure paramters are sane and db is open */
	LM_ASSERT(db != NULL);
	LM_ASSERT(*paddr != NULL);
	addr = *paddr;

	/* Split the username and domain */
	msd_db_get_user_domain(&escuser, &escdomain, addr);

	snprintf(qbuffer, sizeof(qbuffer),
		 "select get_status(actual_name('%s', '%s', 4), '%s', 4) where actual_name('%s', '%s', 4) is not NULL;",
		 escuser, escdomain, escdomain, escuser, escdomain);

	/* Do the query.  An return the status */
	retval = db_do_query(NULL, qbuffer);
	
	/* Free strings */
	LM_FREE(escuser);
	LM_FREE(escdomain);

	return retval;
}
