#!/bin/sed -f
#
# COPYRIGHT INFORMATION - DO NOT REMOVE
# "Portions Copyright (c) 2000-2001 LinuxMagic Inc. All Rights Reserved.
#
# This file contains Original Code and/or Modifications of Original Code as
# defined in and that are subject to the Free Source Code License Version
# 1.0 (the 'License'). You may not use this file except in compliance with
# the License. Please obtain a copy of the License at:
#
# http://www.linuxmagic.com/opensource/licensing/
#
# and read it before using this file.
#
# The Original Code and all software distributed under the License are
# distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
# EXPRESS OR IMPLIED, AND LINUXMAGIC HEREBY DISCLAIMS ALL SUCH WARRANTIES,
# INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. Please see
# the License for the specific language governing rights and limitations
# under the License."
#
# Please read the terms of this license carefully. By using or downloading
# this software or file, you are accepting and agreeing to the terms of this
# license with LinuxMagic Inc. If you are agreeing to this license on behalf
# of a company, you represent that you are authorized to bind the company to
# such a license. If you do not meet this criterion or you do not agree to
# any of the terms of this license, do NOT download, distribute, use or alter
# this software or file in any way.
#
# Author: Burton Samograd (burton@wizard.ca)
# CVS Id: $Id: init_spamdir_sh.sed,v 1.1.10.1 2003/02/14 19:23:25 burton Exp $
#
# DO NOT MODIFY WITHOUT CONSULTING THE LICENSE
#
#
# This will generate the script init_spamdir.sh from
# spam_rules.in
# Run like this:
#     cat spam_rules.in | ./init_spamdir_sh.sed  > init_spamdir.sh
#     sh init_spamdir.sh

1{
a\
\#!/bin/sh \
\
if [ "$1" == "" ] \
then\
	SPAMDIR="$HOME/.magicspam"\
else\
	SPAMDIR=$1\
fi\
\
if [ ! -d "$1" ]\
then\
	echo "Creating SPAMDIR: $SPAMDIR"\
	mkdir $SPAMDIR\
fi
}

#
# Clean the input file 
#
{
# Strip comments and end of line whitespace
s/[[:space:]]*\#.*$//
# Strip beginning of line whitespace 
s/^[[:space:]]*//
# delete blank lines
/^$/d
}

/^$/!{
h
s|^\([[:alnum:]]\+\)[[:space:]]\+\([[:alnum:]_]\+\)[[:space:]]\+\([^[:space:]]\+\)[[:space:]]\+\([^[:space:]]\+\).*|echo \4 > $SPAMDIR/\2;|
s/1/true/
s/0/false/
}
