#include <stdlib.h>
#include <stdio.h>

#include <liblm.h>

int main(int argc, char **argv)
{
  int *ptr1, *ptr2, *ptr3, *ptr4;
  char *oldptr, *newptr;

  ptr1 = ptr2 = ptr3 = ptr4 = NULL;
  
  oldptr = newptr = NULL;
  LM_MALLOC(oldptr, 100);
  newptr = oldptr;
  LM_MEMASSERT(newptr);
  LM_FREE(newptr);
  /* FIXME This next line will cause a seg fault */
  /* LM_FREE(oldptr); */

  LM_MALLOC(ptr1, sizeof(int)*10);
  LM_FREE(ptr1);

  LM_MALLOC(ptr2, sizeof(int)*20);

  LM_MALLOC(ptr3, sizeof(int)*50);
  LM_MALLOC(ptr4, sizeof(int)*200);

  printf("\n\nThis should not produce an error...\n\n");
  memset(ptr2, 0, sizeof(int)*20);
  LM_MEMASSERT(ptr2);
  printf("\n\nThis should bring up an errro...\n\n");
  memset(ptr2, 0, sizeof(int)*21);
  LM_MEMASSERT(ptr2);

  LM_MEMSTAT(stderr);
  
  LM_FREE(ptr2);
  LM_FREE(ptr3);

  /* Should always be called at the end of the program 
     to show any allocated memory left over */
  LM_MEMDUMP(stderr);

  LM_FREE(ptr1);
  printf("\n\nThis should bring up an error and will crash if execution continues...\n\n");
  LM_FREE(ptr1);

  LM_MEMSTAT(stderr);

  return 0;
}
