#include <stdio.h>

#include <liblm.h>

int main(int argc, char **argv)
{
  lm_string_t string, string2, string3, string4;
  size_t bytesread;

  string = string2 = string3 = string4 = NULL;
  

  LM_LOG_INIT("/tmp/garbage");
  
  LM_STRING_NEW(string, "");
  LM_STRING_NEW(string2, "I am string 2");
  LM_STRING_NEW(string3, "I am string 3");

  LM_MEMSTAT(stdout);
  

  LM_STRING_CAT(string, string2);
  puts("string: ");
  puts(LM_STRING_BUFFER(string));
  
  LM_STRING_CAT(string2, string3);
  puts("string2: ");
  puts(LM_STRING_BUFFER(string2));

  LM_STRING_DUP(string4, string3);
  puts("string4: ");
  puts(LM_STRING_BUFFER(string4));
  
  LM_STRING_FREE(string3);
  LM_STRING_CAT(string4, string2);
  puts("string4: ");
  puts(LM_STRING_BUFFER(string4));

  LM_MEMSTAT(stdout);
  LM_MEMDUMP(stdout);
  
  LM_STRING_FREE(string4);
  LM_STRING_FREE(string2);

  LM_STRING_FREE(string);
  puts("\nTYPE SOMETHING: ");
  LM_STRING_FGETS(string, stdin, 1024, bytesread);
  puts("ECHO: ");
  puts(LM_STRING_BUFFER(string));

  LM_STRING_FREE(string);
  LM_STRING_NEW(string, "string with whitespace at the end    \t\r\n\n");
  puts("LM_STRING_CHOP::This string has whitespace on the end:");
  printf(LM_STRING_BUFFER(string));
  puts("END");
  LM_STRING_CHOP(string);
  puts("This string has been chopped:");
  printf(LM_STRING_BUFFER(string));
  puts("END");
  puts("This text should be directly below the above line with no spaces");

  LM_STRING_FREE(string);
  LM_STRING_NEW(string, " \r\n \t \t \r \n");
  puts("LM_STRING_CHOP::This string is all whitespace:");
  printf(LM_STRING_BUFFER(string));
  puts("END");
  LM_STRING_CHOP(string);
  puts("This is the whitespace string chopped:");
  printf(LM_STRING_BUFFER(string));
  puts("END");
  puts("There should only be END on the above line");
  
  LM_STRING_FREE(string);
  LM_STRING_NEW(string, "    \t\r\n\nstring with whitespace at the beginning");
  puts("LM_STRING_CHOP_HEAD::This string has whitespace at the start:");
  puts("START");
  printf(LM_STRING_BUFFER(string));
  puts("END");
  LM_STRING_CHOP_HEAD(string);
  puts("This string has been chopped:");
  puts("START");
  printf(LM_STRING_BUFFER(string));
  puts("END");
  puts("This text should be directly below the above line with no spaces");

  LM_STRING_FREE(string);
  LM_STRING_NEW(string, " \r\n \t \t \r \n");
  puts("LM_STRING_CHOP_HEAD::This string is all whitespace:");
  puts("START");
  printf(LM_STRING_BUFFER(string));
  puts("END");
  LM_STRING_CHOP_HEAD(string);
  puts("This is the whitespace string head chopped:");
  puts("START");
  printf(LM_STRING_BUFFER(string));
  puts("END");
  puts("There should only be START and END at the start of two lines with no space between");
  
  LM_STRING_FREE(string);

  LM_MEMSTAT(stdout);
  LM_MEMDUMP(stdout);
  
  return 0;
}
