/*
 * COPYRIGHT INFORMATION - DO NOT REMOVE
 * "Portions Copyright (c) 2000-2001 LinuxMagic Inc. All Rights Reserved.
 *
 * This file contains Original Code and/or Modifications of Original Code as
 * defined in and that are subject to the Free Source Code License Version
 * 1.0 (the 'License'). You may not use this file except in compliance with
 * the License. Please obtain a copy of the License at:
 *
 * http://www.linuxmagic.com/opensource/licensing/
 *
 * and read it before using this file.
 *
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND LINUXMAGIC HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. Please see
 * the License for the specific language governing rights and limitations
 * under the License."
 *
 * Please read the terms of this license carefully. By using or downloading
 * this software or file, you are accepting and agreeing to the terms of this
 * license with LinuxMagic Inc. If you are agreeing to this license on behalf
 * of a company, you represent that you are authorized to bind the company to
 * such a license. If you do not meet this criterion or you do not agree to
 * any of the terms of this license, do NOT download, distribute, use or alter
 * this software or file in any way.
 *
 * Author: Burton Samograd (burton@wizard.ca)
 * CVS Id: $Id: config_virus_rule.h,v 1.2 2003/02/04 22:35:02 burton Exp $
 *
 * DO NOT MODIFY WITHOUT CONSULTING THE LICENSE
 */

#include <liblm.h>

#ifndef _CONFIG_VIRUS_RULE_H
#define _CONFIG_VIRUS_RULE_H

typedef struct tag_config_virus_rule_t
{
  lm_config_bool_t all_global_rules;
#define VIRUS_CONTROL_ALL_GLOBAL_RULES_DEFAULT 0
#define VIRUS_CONTROL_ALL_GLOBAL_RULES \
"all_global_rules"
   lm_config_bool_t virus_check;
#define VIRUS_CONTROL_VIRUS_CHECK_DEFAULT 0
#define VIRUS_CONTROL_VIRUS_CHECK \
"virus_check"
} config_virus_rule_t;

int config_virus_rule_load(lm_string_t addr, 
		config_virus_rule_t *ruledata, lm_string_t dotvirus); 
int config_virus_rule_free(config_virus_rule_t *ruledata); 
int config_virus_rule_read(config_virus_rule_t* globalrules, config_virus_rule_t *ruledata);

extern config_virus_rule_t global_virus_rules; 

#endif
